/*** SUP3D.C ***/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <conio.h>

float A, B,                       /* Coordenadas do centro da tela           */
      TAM = 40,                   /* Coeficiente de ampliacao                */
      nu = 70, nv = 70,
      fi = -M_PI/7, teta = -M_PI/7;
float proj_X, proj_Y;

/* ------------------------------------------------------------------------- */

float f1(float x, float y) { return x; }
float f2(float x, float y) { return y; }
float f3(float x, float y) { return sin((x*x + y*y)/4); }

/* ------------------------------------------------------------------------- */

void IniciaModoGrafico(void) {

/* Inicializa o modo grafico. */

  int gm, gd = DETECT;

  /* registerbgidriver(EGAVGA_driver); */
  initgraph(&gd, &gm, "");
  if (graphresult() != grOk) {
    printf("\nERRO na mudana para o modo grfico.\n");
    exit(1); /* Encerra a execucao do programa */
  }
}

/* ------------------------------------------------------------------------ */

void ProjetaPonto(float x, float y, float z) {

/* Calcula as coordenadas do ponto (x, y, z) no plano de projecao. */

  proj_X = y*cos(teta) + x*sin(teta);
  proj_Y = z*cos(fi) + x*cos(teta)*sin(fi) - y*sin(fi)*sin(teta);
}

/* ------------------------------------------------------------------------- */

void DesenhaEixos(int tam, int cor1, int cor2) {

/* Desenha os eixos x, y, z usando tamanho e cores especificados */

  float X0, Y0, X, Y;
  int x_x, x_y, y_x, y_y, z_x, z_y;

  setcolor(cor1);

  ProjetaPonto(0, 0, 0); X0 = proj_X, Y0 = proj_Y;
  ProjetaPonto(tam, 0, 0); X = proj_X, Y = proj_Y;
  line(A + X0*TAM, B - Y0*TAM, A + X*TAM, B - Y*TAM);
  x_x = A + X*TAM; x_y = B - Y*TAM;

  ProjetaPonto(0, tam, 0); X = proj_X, Y = proj_Y;
  line(A + X0*TAM, B - Y0*TAM, A + X*TAM, B - Y*TAM);
  y_x = A + X*TAM; y_y = B - Y*TAM;

  ProjetaPonto(0, 0, tam); X = proj_X, Y = proj_Y;
  line(A + X0*TAM, B - Y0*TAM, A + X*TAM, B - Y*TAM);
  z_x = A + X*TAM; z_y = B - Y*TAM;

  setcolor(cor2);
  outtextxy(x_x, x_y, "x");
  outtextxy(y_x, y_y, "y");
  outtextxy(z_x, z_y, "z");
}

/* ------------------------------------------------------------------------- */

void DesenhaSuperficie(float umin, float umax, float vmin, float vmax,int cor){

/* Usando a  cor especificada, desenha a superficie definida pelas  equacoes
   parametricas (f1(u, v), f2(u, v), f3(u, v)) usando pequenos quadrilateros.
   E' usado como dominio o retangulo [umin, umax] x [vmin, vmax]. */

  float u, v, xp1, yp1, zp1, xp2, yp2, zp2, xp3, yp3, zp3, xp4, yp4, zp4,
	X, Y, incrU, incrV;
  int xq1, xq2, xq3, xq4, yq1, yq2, yq3, yq4;

  incrU = (umax - umin)/nu;
  incrV = (vmax - vmin)/nv;

  setcolor(cor);

  for (u = umin + incrU; u <= umax + incrU/2; u += incrU)
    for (v = vmin + incrV; v <= vmax + incrV/2; v += incrV) {

      xp1 = f1(u, v);
      yp1 = f2(u, v);
      zp1 = f3(u, v);

      xp2 = f1(u - incrU, v);
      yp2 = f2(u - incrU, v);
      zp2 = f3(u - incrU, v);

      xp3 = f1(u, v - incrV);
      yp3 = f2(u, v - incrV);
      zp3 = f3(u, v - incrV);

      xp4 = f1(u - incrU, v - incrV);
      yp4 = f2(u - incrU, v - incrV);
      zp4 = f3(u - incrU, v - incrV);

      ProjetaPonto(xp1, yp1, zp1); X = proj_X, Y = proj_Y;
      xq1 = A + X*TAM; yq1 = B - Y*TAM;
      ProjetaPonto(xp2, yp2, zp2); X = proj_X, Y = proj_Y;
      xq2 = A + X*TAM; yq2 = B - Y*TAM;
      ProjetaPonto(xp3, yp3, zp3); X = proj_X, Y = proj_Y;
      xq3 = A + X*TAM; yq3 = B - Y*TAM;
      ProjetaPonto(xp4, yp4, zp4); X = proj_X, Y = proj_Y;
      xq4 = A + X*TAM; yq4 = B - Y*TAM;

      line (xq1, yq1, xq2, yq2);
      line (xq4, yq4, xq2, yq2);
      line (xq3, yq3, xq4, yq4);
      line (xq3, yq3, xq1, yq1);
    }
}

/* ------------------------------------------------------------------------- */

void main(void) {  /* Funao principal */
  IniciaModoGrafico();
  A = getmaxx()/2, B = getmaxy()/2;
  DesenhaSuperficie(-6, 6, -6, 6, GREEN);
  DesenhaEixos(3, WHITE, LIGHTRED);
  getch();
  closegraph();
}

/* ------------------------------------------------------------------------- */

/*** FIM DE "SUP3D.C" ***/